<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'landing';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// 如果已经有数据提交，则直接显示数据页面
if ($dou->num_rows($dou->query("SELECT * FROM " . $dou->table('landing_data')))) {
    $rec = 'landing_data_list';
} else {
    $rec = 'landing_list';
}

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : $rec;

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/landing/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('act', $act);

/**
 * +----------------------------------------------------------
 * 落地页列表
 * +----------------------------------------------------------
 */
if ($rec == 'landing_list') {
    $smarty->assign('ur_here', $_LANG['landing']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['landing_add'],
            'href' => 'landing.php?rec=add' 
    ));
    
    // 获取参数
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    if ($keyword) {
        $where = " WHERE name LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('landing') . $where . " ORDER BY landing_id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, 'landing.php?rec=landing_list', $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $landing_list[] = array (
                "landing_id" => $row['landing_id'],
                "name" => $row['name'],
                "show_home_link" => $dou->data_lang_format('landing_show_home_link_', $row['show_home_link']),
                "status" => $dou->data_lang_format('landing_status_', $row['status']),
                "url" => $dou->rewrite_url('landing', $row['landing_id']),
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('landing_list', $landing_list);
    
    $smarty->display('landing.htm');
} 

/**
 * +----------------------------------------------------------
 * 落地页添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['landing_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['landing'],
            'href' => 'landing.php?rec=landing_list' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('landing_action', 'insert');
    $smarty->assign('item_id', $dou->auto_id('landing'));
    
    $smarty->display('landing.htm');
} 

elseif ($rec == 'insert') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['landing_name'] . $_LANG['is_empty']);

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('landing') . " (landing_id, name, content_top, content_middle, content_bottom, back_url, show_home_link, status)" . " VALUES (NULL, '$_POST[name]', '$_POST[content_top]', '$_POST[content_middle]', '$_POST[content_bottom]', '$_POST[back_url]', '$_POST[show_home_link]', '$_POST[status]')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['landing_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['landing_add'] . $_LANG['success'], 'landing.php?rec=landing_list');
} 

/**
 * +----------------------------------------------------------
 * 落地页编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['landing_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['landing_list'],
            'href' => 'landing.php?rec=landing_list' 
    ));
 
    // 验证并获取合法的ID
    $landing_id = $check->is_number($_REQUEST['landing_id']) ? $_REQUEST['landing_id'] : '';
    
    // 获取落地页信息
    $landing = $dou->get_row('landing', '*', "landing_id = '$landing_id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('item_id', $id);
    $smarty->assign('landing_action', 'update');
    $smarty->assign('landing', $landing);
    
    $smarty->display('landing.htm');
} 

elseif ($rec == 'update') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['landing_name'] . $_LANG['is_empty']);

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('landing') . " SET name = '$_POST[name]', content_top = '$_POST[content_top]', content_middle = '$_POST[content_middle]', content_bottom = '$_POST[content_bottom]', back_url = '$_POST[back_url]', show_home_link = '$_POST[show_home_link]', status = '$_POST[status]' WHERE landing_id = '$_POST[landing_id]'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['landing_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['landing_edit_succes'], 'landing.php?rec=landing_list');
}

/**
 * +----------------------------------------------------------
 * 落地页删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $landing_id = $check->is_number($_REQUEST['landing_id']) ? $_REQUEST['landing_id'] : $dou->dou_msg($_LANG['illegal'], 'landing.php?rec=landing_list');
 
    $name = $dou->get_one("SELECT name FROM " . $dou->table('landing') . " WHERE landing_id = '$landing_id'");
    
    if (isset($_POST['confirm']) ? $_POST['confirm'] : '') {
        $dou->create_admin_log($_LANG['landing_del'] . ': ' . $name);
        $dou->delete('landing', "landing_id = $landing_id", 'landing.php?rec=landing_list');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'landing.php?rec=landing_list', '', '30', "landing.php?rec=del&landing_id=$landing_id");
    }
}

/**
 * +----------------------------------------------------------
 * 数据列表
 * +----------------------------------------------------------
 */
if ($rec == 'landing_data_list') {
    $smarty->assign('ur_here', $_LANG['landing_data_list']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['landing_list'],
            'href' => 'landing.php?rec=landing_list' 
    ));
    
    // 获取参数
    $landing_id = $check->is_number($_REQUEST['landing_id']) ? $_REQUEST['landing_id'] : 0;
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    $where = $landing_id ? " AND landing_id = '$landing_id'" : '';
    if ($keyword) {
        $where = " AND data_box LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
    
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('landing_data') . $where . " ORDER BY id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'landing.php?rec=landing_data_list' . ($landing_id ? '&landing_id=' . $landing_id : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $landing_data_list[] = array (
                "id" => $row['id'],
                "landing" => $dou->get_row('landing', 'landing_id, name', "landing_id = '$row[landing_id]'"),
                "contact" => $row['contact'],
                "phone" => $row['phone'],
                "ip" => $row['ip'],
                "status" => $dou->data_lang_format('landing_data_status_', $row['status']),
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('landing_data_list', $landing_data_list);
    $smarty->assign('landing_list', get_landing_list($landing_id));
    
    $smarty->display('landing.htm');
}

/**
 * +----------------------------------------------------------
 * 数据处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'landing_data_check') {
    // 验证并获取合法的ID
    $landing_id = $check->is_number($_REQUEST['landing_id']) ? $_REQUEST['landing_id'] : '';
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    // 更新状态
    $dou->query("UPDATE " . $dou->table('landing_data') . " SET status = '1' WHERE id = '$id'");
    
    $dou->dou_header("landing.php?rec=landing_data_list&landing_id=$landing_id");
}    

/**
 * +----------------------------------------------------------
 * 自定义选项删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'landing_data_del') {
    // 验证并获取合法的ID
    $landing_id = $check->is_number($_REQUEST['landing_id']) ? $_REQUEST['landing_id'] : '';
    $back_url = 'landing.php?rec=landing_data_list' . ($landing_id ? "&landing_id=$landing_id" : '');
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], $back_url);
 
    if (isset($_POST['confirm']) ? $_POST['confirm'] : '') {
        $dou->create_admin_log($_LANG['landing_data_del'] . ': ' . $id);
        $dou->delete('landing_data', "id = $id", $back_url);
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $id, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], $back_url, '', '30', "landing.php?rec=landing_data_del&landing_id=$landing_id&id=$id");
    }
}

/**
 * +----------------------------------------------------------
 * 获取表单列表
 * +----------------------------------------------------------
 */
function get_landing_list($cur_landing_id = '') {
    $sql = "SELECT landing_id, name FROM " . $GLOBALS['dou']->table('landing') . " ORDER BY landing_id ASC";
    $query = $GLOBALS['dou']->query($sql);
    while ($row = $GLOBALS['dou']->fetch_array($query)) {
        $landing_list[] = array (
                "landing_id" => $row['landing_id'],
                "name" => $row['name'],
                "cur" => $row['landing_id'] == $cur_landing_id ? true : false
        );
    }

    return $landing_list;
}

?>