<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'submit';
$subbox = array(
        "module" => 'landing',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'landing';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// 验证并获取合法REQUEST
$id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'info';

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'landing', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 落地页
 * +----------------------------------------------------------
 */
if ($rec == 'detail') {
    /* 获取详细信息 */
    $landing_info = $dou->get_row('landing', '*', "landing_id = '$id' AND status = '1'");
    
    if (!$landing_info) {
        $dou->dou_msg($GLOBALS['_LANG']['page_wrong'], HOME_URL);
    }

    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->set_token('landing_submit'));
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('landing'));
    $smarty->assign('ur_here', $dou->ur_here('landing'));
    $smarty->assign('head', $_LANG['landing']);
    $smarty->assign('landing', $landing_info);
 
    $smarty->display('landing.dwt');
}

/**
 * +----------------------------------------------------------
 * 落地页提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'submit') {
    $landing_id = $check->is_number($_REQUEST['landing_id']) ? $_REQUEST['landing_id'] : '';
    
    // 格式化数据
    $ip = $dou->get_ip();
    
    // 判断是否为空
    $wrong = $check->fn_empty('landing_data', 'contact, phone');
 
    // 判断是否含有非法字符
    $wrong = $check->fn_illegal_char('landing_data', 'contact, phone');
 
    if (!$check->is_telphone($_POST['phone'])) {
        $wrong['phone'] = $_LANG['landing_data_phone_cue'];
    }
 
    // 检查IP是否频繁咨询
    if (is_water($ip)) {
        $_POST['landing_data_is_water'] = '';
        $wrong['landing_data_is_water'] = $_LANG['landing_data_is_water'];
    }
 
    // AJAX验证落地页
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['edit']);
    }
 
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'landing_submit');
    
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);

    // 格式化数据
    $add_time = time();
    $back_url = $dou->get_one("SELECT back_url FROM " . $dou->table('landing') . " WHERE landing_id = '$landing_id'");
    $back_url = $back_url ? $back_url : $dou->param($_URL['landing'] . '&id=' . $landing_id);
    
    // 插入报名
    $dou->query("INSERT INTO " . $dou->table('landing_data') . " (id, landing_id, contact, phone, ip, add_time)" . " VALUES (NULL, '$landing_id', '$_POST[contact]', '$_POST[phone]', '$ip', '$add_time')");
    
    $dou->dou_msg($_LANG['landing_submit'] . $_LANG['success'], $back_url);
}

/**
 * +----------------------------------------------------------
 * 防灌水
 * +----------------------------------------------------------
 */
function is_water($ip) {
    $unread = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('landing_data') . " WHERE ip = '$ip' AND status = 0");
    
    // 如果管理员未回复的咨询数量大于1
    if ($unread >= 2)
        return true;
}

?>